.\" $NetBSD: veriexecctl.8,v 1.34 2008/02/18 10:37:19 elad Exp $
.\"
.\" Copyright (c) 1999
.\"	Brett Lymn - blymn@baea.com.au, brett_lymn@yahoo.com.au
.\"
.\" This code is donated to The NetBSD Foundation by the author.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. The name of the Author may not be used to endorse or promote
.\"    products derived from this software without specific prior written
.\"    permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	$Id: veriexecctl.8,v 1.35 2008/08/31 23:40:19 dholland Exp $
.\"
.Dd August 31, 2008
.Dt VERIEXECCTL 8
.Os
.Sh NAME
.Nm veriexecctl
.Nd manage the
.Em Veriexec
subsystem
.Sh SYNOPSIS
.Nm
.Op Fl ekv
.Cm load Op file
.Nm
.Cm delete Ar file | mount_point
.Nm
.Cm dump
.Nm
.Cm flush
.Nm
.Cm query Ar file
.Sh DESCRIPTION
The
.Nm
command is used to manipulate
.Em Veriexec ,
the
.Nx
file integrity subsystem.
.Ss Commands
.Bl -tag -width XXXX
.It Cm load Op file
Load the fingerprint entries contained in
.Ar file ,
if specified, or the default signatures file otherwise.
.Pp
This operation is only allowed in learning mode (strict level zero).
.Pp
The following flags are allowed with this command:
.Bl -tag -width indent
.It Fl e
Evaluate fingerprint on load, as opposed to when the file is accessed.
.It Fl k
Keep the filenames in the entry for more accurate logging.
.It Fl v
Enable verbose output.
.El
.It Cm delete Ar file | mount_point
Delete either a single entry
.Ar file
or all entries on
.Ar mount_point
from being monitored by
.Em Veriexec .
.It Cm dump
Dump the
.Em Veriexec
database from the kernel.
Only entries that have the filename will be presented.
.Pp
This can be used to recover a lost database:
.Bd -literal -offset indent
# veriexecctl dump \*[Gt] /etc/signatures
.Ed
.It Cm flush
Delete all entries in the
.Em Veriexec
database.
.It Cm query Ar file
Query
.Em Veriexec
for information associated with
.Ar file :
Filename, mount, fingerprint, fingerprint algorithm, evaluation status,
and entry type.
.El
.Sh FILES
.Bl -tag -width /etc/signatures -compact
.It Pa /dev/veriexec
.Em Veriexec
pseudo-device
.It Pa /etc/signatures
default signatures file
.El
.Sh SEE ALSO
.Xr veriexec 4 ,
.Xr veriexec 5 ,
.Xr security 8 ,
.Xr veriexec 8 ,
.Xr veriexecgen 8
.Sh HISTORY
.Nm
first appeared in
.Nx 2.0 .
.Sh AUTHORS
.An Brett Lymn Aq blymn@NetBSD.org
.An Elad Efrat Aq elad@NetBSD.org
.Sh NOTES
The kernel is expected to have the
.Dq veriexec
pseudo-device.
